/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tanks;

/**
 *
 * @author bli
 */
public class Position {

    private final double x;
    private final double y;

    private static final double fieldWidth = 1000;
    private static final double fieldHeight = 1000;

    public Position() {
        this.x = Math.random() * fieldWidth;
        this.y = Math.random() * fieldHeight;
    }

    public Position(double x, double y) throws PositionException {
        if (!(x >= 0 && x < fieldWidth && y >= 0 && y < fieldHeight)) {
            throw new PositionException();
        }
        this.x = x;
        this.y = y;
    }

    public double distance(Position position) {
        return Math.sqrt(Math.pow(x - position.x, 2) + Math.pow(y - position.y, 2));
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    @Override
    public String toString() {
        return "Position{" + "x=" + String.format("%6.2f", x) + ", y=" + String.format("%6.2f", y) + '}';
    }

}
