/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tanks;

/**
 *
 * @author bli
 */
public class Tank {

    public static final double maxHP = 100;
    public static final double shootDistance = 500;
    public static final double fuelConsumption = 0.05;

    private final String name;
    private Position position;
    private int ammo = 10;
    private double fuel = 100;
    private double HP = maxHP;

    public Tank(String name) {
        this.name = name;
        position = new Position();
    }

    public boolean isDestroyed() {
        return HP <= 0;
    }

    public void damage(double damage) {
        HP = Math.max(HP - damage, 0);
    }

    public boolean move(Position newPosition) {
        double fuelNeeded = position.distance(newPosition) * fuelConsumption;
        if (isDestroyed() || fuel < fuelNeeded) {
            return false;
        }
        fuel -= fuelNeeded;
        position = newPosition;
        return true;
    }

    public double shoot(Tank target) {
        double damage = Math.max((shootDistance - position.distance(target.getPosition())) / shootDistance, 0) * maxHP;
        if (isDestroyed() || ammo == 0) {
            return 0;
        }
        ammo -= 1;
        target.damage(damage);
        return damage;
    }

    public Position getPosition() {
        return position;
    }

    public int getAmmo() {
        return ammo;
    }

    public double getFuel() {
        return fuel;
    }

    @Override
    public String toString() {
        return "Tank:" + "\n\tname=" + name + "\n\tposition=" + position +
                "\n\tammo=" + ammo + "\n\tfuel=" + String.format("%6.2f", fuel)
                + "\n\tHP=" + String.format("%6.2f", HP);
    }
}
