/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tanks;

/**
 *
 * @author bli
 */
public class Tanks {

    private final Player[] players;

    public Tanks() {
        players = new Player[2];
        players[0] = new Player("Player 1");
        players[1] = new Player("Player 2");
    }

    public Player whoWon() {
        for (int i = 0; i < 2; i++) {
            if (players[i].allDestroyed()) {
                return players[1 - i];
            }
        }
        return null;
    }

    public boolean isDraw() {
        return !(players[0].canDamage(players[1]) || players[1].canDamage(players[0]));
    }

    public void startGame() {
        while (true) {
            for (int i = 0; i < 2; i++) {
                Player player = players[i];
                Player opponent = players[1-i];
                printGame();
                System.out.println("Next player: " + player.getName());
                player.move(opponent);
                if (player.isGivenUp()) {
                    System.out.println(players[1 - i].getName() + " won the game!");
                    return;
                }
                if (whoWon() != null) {
                    printGame();
                    System.out.println(whoWon().getName() + " won the game!");
                    return;
                }
                if (isDraw()) {
                    printGame();
                    System.out.println("The game is a draw.");
                    return;
                }
            }
        }
    }

    public void printGame() {
        System.out.println("The state of the game:");
        for (Player player : players) {
            System.out.println(player);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        Tanks tanks = new Tanks();
        tanks.startGame();
    }
}